#ifndef MSGS_H
#define MSGS_H

enum {
	AM_SENSORSMSG		= 40,
	AM_TIMERMSG			= 41,
	AM_PHOTOMSG 		= 42,
	AM_TEMPMSG			= 43,
	AM_HALLMSG			= 44
};

uint32_t VALINI_MUESTREO = 20000; //valor inicial por defecto (20 segundos)
uint32_t VALACT_MUESTREO; //valor actual timer
uint32_t VALSIN_MUESTREO = 0; //valor parada timer
uint8_t  MAX_INTENTOS = 3;
uint32_t  CONSTANTE_TEMP = 21300; //Valor constante conversión grados
uint32_t  FACTOR_CONV_TEMP = 425; //Factor de conversión grados
uint16_t  TEMPERATURA_MIN = 15; //MIN temperatura para activar calefacción
uint16_t  TEMPERATURA_MAX = 27; //MAX temperatura para activar aire acondicionado
uint16_t  LUMINOSIDAD_MIN = 200; //MIN luminosidad para encender luz
uint32_t  BLINK_MAXTEMP = 600;  //Parpadeo MAX temperatura
uint32_t  APAGADO_LED_HALL = 1500;	//Duración temporizado apagado led indicador hall

typedef nx_struct SensorsMsg {
		 
	nx_uint16_t moteId;
	nx_uint16_t countsTemp;
	nx_uint16_t countsPhoto;
	nx_uint16_t countsBat;
	nx_uint16_t vrefmilivolts;
	//nx_uint16_t counter;
	nx_uint8_t tipo; //1-consulta luz,  2-consulta temperatur,  3-consultar todos 
} SensorsMsg; 

typedef nx_struct HallMsg {
	nx_uint16_t moteId;
	nx_bool hallOn;
} HallMsg; 

typedef nx_struct TimerMsg{
	nx_uint16_t moteId;
	nx_uint32_t tempor;
	nx_bool consulta;
} TimerMsg;

typedef nx_struct PhotoMsg{
	nx_uint16_t moteId;
	nx_uint16_t  photoMin;
	nx_bool consulta;
} PhotoMsg;

typedef nx_struct TempMsg{
	nx_uint16_t moteId;
	nx_uint16_t tempMin;
	nx_uint16_t tempMax;
	nx_bool consulta;
} TempMsg;

#endif /* MSGS_H */
