package domus;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.Timer;

import java.text.*;

public class ControlRemoto extends JPanel implements ActionListener, ChangeListener, WindowListener {
    
	static final long serialVersionUID = 1;
    public JLabel banner;
    public JColorChooser tcc;
    public static JFrame frame;
    static ComponentListener listener;
    protected final static String BOTON_EXIT = "Cerrar TinyDomus";
    protected final static String BOTON_CONSULTA_PARAM = "Consultar Parametros";
    protected final static String BOTON_PARADA = "Parar Muestreo";
    protected final static String BOTON_CONSULTA_TEMP = "Sensor Temperatura";
    protected final static String BOTON_CONSULTA_PHOTO = "Sensor Luminosidad";
    protected final static String LF_METAL = "Metal";
    protected final static String LF_SYSTEM = "System";
    protected final static String LF_MOTIF = "Motif";
    protected final static String COMBO_TIEMPO = "ComboTiempo";
    protected final static String COMBO_TEMPERATURA = "ComboTemp";
    protected final static String CAMBIAR_TIMER = "CambiarTimer";
    protected final static String CAMBIAR_MIN_PHOTO = "CambiarPhotoMin";
    protected final static String CAMBIAR_MIN_TEMP = "CambiarTempMin";
    protected final static String CAMBIAR_MAX_TEMP = "CambiarTempMax";
    private final static int RETARDO = 900;
    protected final static int SENSOR_TEMP = 0;
    protected final static int SENSOR_LUZ = 1;
    protected final static int SENSOR_HALL = 2;
    protected final String NEWLINE = "\n";
    protected final String NEWLINE_DOBLE = "\n\n";
    protected final static String TIMER_BLINK = "timerBlink";
    protected final static String TIMER_WATCHDOG = "timerWatchDog";
    protected final static int PARPADEO = 600;
    protected final static int WATCHDOG = 7000;
    protected final static int MAX_LINEAS_MENSAJES = 200;
    private final static short SIN_INICIALIZAR = -999;
    private final static short TIMER_PARADA = 0;
    private static int TIMER_DEFECTO = 20;
    private final static int TIMER_MIN_MIN = 1; 
    private final static int TIMER_MIN_MAX = 60;
    private final static int TIMER_SEG_MIN = 10;
    private final static int TIMER_SEG_MAX = TIMER_MIN_MAX * 60;
    private static int LECTURA_PHOTOSENSOR = SIN_INICIALIZAR;
    private static int PHOTOMIN_DEFECTO = 200;
    private final static int PHOTOMIN_MIN = 0;
    private final static int PHOTOMIN_MAX = 999; 
    private static double LECTURA_TEMPERATURA = SIN_INICIALIZAR;
    private static double TEMPMIN_DEFECTO = 15.00;
    private static double TEMPMIN_MIN = 0.00;
    private static double TEMPMIN_MAX = 30.00;
    private static double TEMPMAX_DEFECTO = 27.00;
    private static double TEMPMAX_MIN = 15.00;
    private static double TEMPMAX_MAX = 99.00;
    private static final String SEGUNDOS = "Segundos";
    private static final String MINUTOS = "Minutos";
    private static String UNIDAD_TIEMPO = SEGUNDOS;
    private static final String CELSIUS = "Grados Celsius";
    private static final String FARENHEIT = "Grados Farenheit";
    private static String UNIDAD_TEMPERATURA = CELSIUS;
    private final static boolean  CAMBIAR_VALOR = true;
    private final boolean DEBUG = false;
    
    private JTabbedPane panelEtiquetas;
    private JTextField tfTemp;
    private JTextField tfPhoto;
    private JTextField tfHall;
    private JTextField tfTimer;
    private JTextField tfPhotoMin;
    private JTextField tfTempMin;
    private JTextField tfTempMax;
    private JTextArea taEventos;
    private Timer timerBlink;
    private Timer timerWatchDog;
    private boolean iniParam = true;
    private short secuencia = 0;
    
    private DecimalFormat fmt2Decimales;
    private DecimalFormat fmt2Enteros;
    private DecimalFormat fmt3Enteros;
    private Validador validacion = new Validador();
    
    private TinyDomus mensajesDomus;
    
    public ControlRemoto() {
        super(new BorderLayout());

        //Configuramos el banner
        banner = new JLabel("TinyDomus 1.0",
                            JLabel.CENTER);
        banner.setForeground(Color.yellow);
        banner.setBackground(Color.blue);
        banner.setOpaque(true);
        banner.setFont(new Font("SansSerif", Font.BOLD, 24));
        banner.setPreferredSize(new Dimension(80, 65));

        JPanel bannerPanel = new JPanel(new BorderLayout());
        bannerPanel.add(banner, BorderLayout.CENTER);
        bannerPanel.setBorder(BorderFactory.createTitledBorder("Control Remoto"));
        add(bannerPanel, BorderLayout.PAGE_START);
        
        //Configuramos un JTabbedPane con 2 etiquetas:       
        panelEtiquetas = new JTabbedPane();
        //Uno para la lectura de sensores y settings
        panelEtiquetas.addTab("Controles", panelCentral());
        panelEtiquetas.setMnemonicAt(0, KeyEvent.VK_1);
        //Otro para registrar todos los mensajes
        panelEtiquetas.addTab("Registro Mensajes", registroMensajes());
        panelEtiquetas.setMnemonicAt(1, KeyEvent.VK_2);
        //Añadimos los paneles al Form
        add(panelEtiquetas, BorderLayout.CENTER);
        
        frame = new JFrame("ControlRemoto");
        frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
        frame.addWindowListener(this);
        
        //Obtenemos una instancia de TinyDomus
        mensajesDomus = TinyDomus.getTinyDomus();
    
        //Timer para el parpadeo que simula encendido aire acondicionado	
        timerBlink = new Timer( PARPADEO , new TimerListener(this));
        timerBlink.setActionCommand(TIMER_BLINK);
        timerBlink.setInitialDelay(0);
		
		//Timer para mantener la mota base activa y evitar el reboot	
        timerWatchDog = new Timer( WATCHDOG , new TimerListener(this));
        timerWatchDog.setActionCommand(TIMER_WATCHDOG);
        timerWatchDog.setInitialDelay(0);
        timerWatchDog.start();
        
    }
    
    protected JPanel panelCentral() {
    
    	JPanel panelCentral = new JPanel();
        panelCentral.setBorder(BorderFactory.createEmptyBorder());
        panelCentral.setLayout(new BoxLayout(panelCentral, BoxLayout.Y_AXIS));
        panelCentral.add(lecturaSensores());
        panelCentral.add(consultaManual());
        panelCentral.add(configSensores());
        panelCentral.add(panelSalir());
        
        return panelCentral;
    }
    
    protected JPanel lecturaSensores() {
        
        JPanel panelLecturas = new JPanel();
        panelLecturas.setBorder(BorderFactory.createTitledBorder("Muestreo Sensores"));
        panelLecturas.setLayout(new BoxLayout(panelLecturas, BoxLayout.X_AXIS));
        
        Dimension size = new Dimension(210, 160);
        
        JPanel sensorTemp = new JPanel();
        sensorTemp.setBorder(BorderFactory.createTitledBorder("Temperatura"));
        sensorTemp.setLayout(new GridLayout(1,1));
        sensorTemp.setMaximumSize(size);
        sensorTemp.setPreferredSize(size);
        sensorTemp.setMinimumSize(size);
        tfTemp = new JTextField(4);
        Font fTextField=new Font(tfTemp.getFont().getName(),
           tfTemp.getFont().getStyle(),45);  
        sensorTemp.setMaximumSize(size);
        sensorTemp.setPreferredSize(size);
        sensorTemp.setMinimumSize(size);
              tfTemp.setEditable(false);
        tfTemp.setBackground(Color.WHITE);
        tfTemp.setFocusable(false);
        tfTemp.setHorizontalAlignment(JTextField.CENTER);
        tfTemp.setFont(fTextField);
        sensorTemp.add(tfTemp);
        
        JPanel sensorPhoto = new JPanel();
        sensorPhoto.setBorder(BorderFactory.createTitledBorder("Luminosidad"));
        sensorPhoto.setLayout(new GridLayout(1,1));
        sensorPhoto.setMaximumSize(size);
        sensorPhoto.setPreferredSize(size);
        sensorPhoto.setMinimumSize(size);
        tfPhoto = new JTextField(3);
        tfPhoto.setEditable(false);
        tfPhoto.setBackground(Color.WHITE);
        tfPhoto.setFocusable(false);
        tfPhoto.setHorizontalAlignment(JTextField.CENTER);
        tfPhoto.setFont(fTextField);
        sensorPhoto.add(tfPhoto);
        
        JComponent sensorHall = new JPanel();
        sensorHall.setBorder(BorderFactory.createTitledBorder("Efecto Hall"));
        sensorHall.setLayout(new GridLayout(1,1));
        sensorHall.setMaximumSize(size);
        sensorHall.setPreferredSize(size);
        sensorHall.setMinimumSize(size);
        tfHall = new JTextField(3);
        tfHall.setEditable(false);
        tfHall.setBackground(Color.WHITE);
        tfHall.setFocusable(false);
        tfHall.setHorizontalAlignment(JTextField.CENTER);
        tfHall.setFont(fTextField);
        sensorHall.add(tfHall);
                
        panelLecturas.add(sensorTemp);
        panelLecturas.add(sensorPhoto);
        panelLecturas.add(sensorHall);
        
        return panelLecturas;
    }
    
    protected JPanel consultaManual() {
        
        JPanel panelConsultas = new JPanel();
        panelConsultas.setBorder(BorderFactory.createTitledBorder("Lectura Manual Sensores"));
        panelConsultas.setLayout(new GridLayout(1,2));
        JButton bConsultaTemp = new JButton(BOTON_CONSULTA_TEMP);
        bConsultaTemp.addActionListener(this);
        panelConsultas.add(bConsultaTemp);
        JButton bConsultaPhoto = new JButton(BOTON_CONSULTA_PHOTO);
        bConsultaPhoto.addActionListener(this);
        panelConsultas.add(bConsultaPhoto);
                
        return panelConsultas;
    }
 
    protected JPanel configSensores() {
        inicializarFormatos();
    	JPanel panelConfig = new JPanel();
        panelConfig.setBorder(BorderFactory.createTitledBorder("Configuraciones"));
        //panelConfig.setLayout(new BoxLayout(panelConfig, BoxLayout.X_AXIS));
        panelConfig.setLayout(new GridLayout(0,2));
        //Dimension size = new Dimension(250, 60);
                
        JPanel panelPeriodo = new JPanel();
        panelPeriodo.setBorder(BorderFactory.createTitledBorder("Intervalo Muestreo (" + TIMER_PARADA + " = PARADO)"));
        //tfTimer = new JTextField(fmt2Enteros.format(TIMER_DEFECTO), 2);
        tfTimer = new JTextField("", 2);
        tfTimer.setInputVerifier(validacion);
        tfTimer.setColumns(5);
        Font fTextField2=new Font(tfTemp.getFont().getName(),
                tfTimer.getFont().getStyle(),20);  
        tfTimer.setEditable(true);
        tfTimer.setBackground(Color.WHITE);
        tfTimer.setFocusable(true);
        tfTimer.setHorizontalAlignment(JTextField.CENTER);
        tfTimer.setFont(fTextField2);
        tfTimer.setToolTipText("Pulse [Parar Muestreo] para detenerlo. " + 
        		               "Introduzca un valor > CERO para activarlo" );
        JButton bTimer = new JButton("Cambiar");
        bTimer.setActionCommand(CAMBIAR_TIMER);
        bTimer.addActionListener(this);
        //tfPhotoMin = new JTextField(fmt3Enteros.format(PHOTOMIN_DEFECTO), 3);
        tfPhotoMin = new JTextField("", 3);
        tfPhotoMin.setInputVerifier(validacion);
        tfPhotoMin.setColumns(5);
        tfPhotoMin.setEditable(true);
        tfPhotoMin.setBackground(Color.WHITE);
        tfPhotoMin.setFocusable(true);
        tfPhotoMin.setHorizontalAlignment(JTextField.CENTER);
        tfPhotoMin.setFont(fTextField2);
        JButton bPhotoMin = new JButton("Cambiar");
        bPhotoMin.setActionCommand(CAMBIAR_MIN_PHOTO);
        bPhotoMin.addActionListener(this);
        panelPeriodo.add(tfTimer);
        panelPeriodo.add(bTimer);
        panelPeriodo.add(tfPhotoMin);
        panelPeriodo.add(bPhotoMin);
                
        JPanel panelPhotoMin = new JPanel();
        panelPhotoMin.setBorder(BorderFactory.createTitledBorder("Valor MIN Fotosensor"));
        panelPhotoMin.add(tfPhotoMin);
        panelPhotoMin.add(bPhotoMin);
        
        JPanel panelTempMin = new JPanel();
        panelTempMin.setBorder(BorderFactory.createTitledBorder("MIN Temperatura"));
        //tfTempMin = new JTextField(fmt2Decimales.format(TEMPMIN_DEFECTO), 2);
        tfTempMin = new JTextField("", 2);
        tfTempMin.setInputVerifier(validacion);
        tfTempMin.setColumns(5);
        tfTempMin.setEditable(true);
        tfTempMin.setBackground(Color.WHITE);
        tfTempMin.setFocusable(true);
        tfTempMin.setHorizontalAlignment(JTextField.CENTER);
        tfTempMin.setFont(fTextField2);
        JButton bTempMin = new JButton("Cambiar");
        bTempMin.setActionCommand(CAMBIAR_MIN_TEMP);
        bTempMin.addActionListener(this);
        panelTempMin.add(tfTempMin);
        panelTempMin.add(bTempMin);
        
        JPanel panelTempMax = new JPanel();
        panelTempMax.setBorder(BorderFactory.createTitledBorder("MAX Temperatura"));
        //tfTempMax = new JTextField(fmt2Decimales.format(TEMPMAX_DEFECTO), 2);
        tfTempMax = new JTextField("", 2);
        tfTempMax.setInputVerifier(validacion);
        tfTempMax.setColumns(5);
        tfTempMax.setEditable(true);
        tfTempMax.setBackground(Color.WHITE);
        tfTempMax.setFocusable(true);
        tfTempMax.setHorizontalAlignment(JTextField.CENTER);
        tfTempMax.setFont(fTextField2);
        JButton bTempMax = new JButton("Cambiar");
        bTempMax.setActionCommand(CAMBIAR_MAX_TEMP);
        bTempMax.addActionListener(this);
        panelTempMax.add(tfTempMax);
        panelTempMax.add(bTempMax);
                
        JPanel panelUniTiempo = new JPanel();
        panelUniTiempo.setBorder(BorderFactory.createTitledBorder("Unidades de Tiempo"));
        //panelUniTiempo.setLayout(new GridLayout(1,1));
        String[] uniTimer = { SEGUNDOS, MINUTOS};
        JComboBox cbUniTiempo = new JComboBox(uniTimer);
        cbUniTiempo.setSelectedIndex(0);
        cbUniTiempo.setActionCommand(COMBO_TIEMPO);
        cbUniTiempo.addActionListener(this);
        panelUniTiempo.add(cbUniTiempo);
        
        JPanel panelUniTemp = new JPanel();
        panelUniTemp.setBorder(BorderFactory.createTitledBorder("Unidad Temperatura"));
        //panelUniTemp.setLayout(new GridLayout(2,1));
        String[] uniTemp = { CELSIUS, FARENHEIT};
        JComboBox cbUniTemp = new JComboBox(uniTemp);
        cbUniTemp.setSelectedIndex(0);
        cbUniTemp.setActionCommand(COMBO_TEMPERATURA);
        cbUniTemp.addActionListener(this);
        panelUniTemp.add(cbUniTemp);
                
        panelConfig.add(panelPeriodo);
        panelConfig.add(panelPhotoMin);
        panelConfig.add(panelTempMin);
        panelConfig.add(panelTempMax);
        panelConfig.add(panelUniTiempo);
        panelConfig.add(panelUniTemp);
        
        return panelConfig;
    }

    protected JPanel panelSalir() {
    	
        //Configuramos el panel con los radio button de apariencia y el botón salir
        JPanel panelPie = new JPanel(new GridLayout(0,3));
        Dimension size = new Dimension(620,110);
        panelPie.setMinimumSize(size);
        panelPie.setPreferredSize(size);
        panelPie.setMaximumSize(size);
        //Ponemos los radioButton en un panel de 1 columna
        JPanel radioPanel= new JPanel(new GridLayout(3, 0));
        radioPanel.setBorder(BorderFactory.createTitledBorder("Apariencia"));
        ButtonGroup bg1 = new ButtonGroup();
        JRadioButton rb1 = new JRadioButton();
        rb1.setText(LF_METAL);
        rb1.setActionCommand(LF_METAL);
        rb1.addActionListener(this);
        rb1.setSelected(true);
        bg1.add(rb1);
        JRadioButton rb2 = new JRadioButton();
        rb2.setText(LF_SYSTEM);
        rb2.setActionCommand(LF_SYSTEM);
        rb2.addActionListener(this);
        bg1.add(rb2);
        JRadioButton rb3 = new JRadioButton();
        rb3.setText(LF_MOTIF);
        rb3.setActionCommand(LF_MOTIF);
        rb3.addActionListener(this);
        bg1.add(rb3);
        radioPanel.add(rb1);
        radioPanel.add(rb2);
        radioPanel.add(rb3);
        //Definimos un botón para poder consultar los parámetros en cualquier momento
        JPanel panelConsulta = new JPanel(new GridLayout(2,0));
        panelConsulta.setBorder(BorderFactory.createTitledBorder("Control Remoto"));
        JButton bConsulta = new JButton(BOTON_CONSULTA_PARAM);
        bConsulta.addActionListener(this);
        panelConsulta.add(bConsulta);
        JButton bParada = new JButton(BOTON_PARADA);
        bParada.addActionListener(this);
        panelConsulta.add(bParada);
        //Definimos un subpanel para el JButton Salir
        JPanel panelSalir = new JPanel();
        panelSalir.setBorder(BorderFactory.createTitledBorder("Salir"));
        JButton bSalir = new JButton(BOTON_EXIT);
        bSalir.addActionListener(this);
        panelSalir.add(bSalir);
        
        panelPie.add(radioPanel,BorderLayout.PAGE_START);
        panelPie.add(panelConsulta);
        panelPie.add(panelSalir);
        panelPie.setBorder(BorderFactory.createTitledBorder("Varios"));
        return panelPie;
    }

    //Formulario registro de mensajes recibidos/enviados	
    protected JPanel registroMensajes() {
    	JPanel panelRegistro = new JPanel();
    	taEventos = new JTextArea();
    	taEventos.setEditable(false);
    	taEventos.setLineWrap(true);
        JScrollPane panelScroll = new JScrollPane(taEventos);
        panelScroll.setPreferredSize(new Dimension(610, 545));

    	panelRegistro.add(panelScroll);
    	return panelRegistro;
    }
     
    //Definimos formatos diferentes para los valores del Timer, 
    //el MIN Luminosidad y los valors MIN/MAX Temperatura.
    private void inicializarFormatos() {
        fmt2Enteros = new DecimalFormat("00");
    	//Formato campo valor MIN Fotosensor
    	fmt3Enteros = new DecimalFormat("#000");
    	//Formato campos valores temperatura MIN y MAX
        fmt2Decimales = new DecimalFormat("#0.00");
        

    }

    public void actionPerformed(ActionEvent e) {
    	String command = e.getActionCommand();

    	if (BOTON_EXIT.equals(command)) {
        	System.exit(0);
    	} else if (BOTON_CONSULTA_PARAM.equals(command)) {
    		try {
    		   consultarParametros();
    		} catch (Exception ex) { if (DEBUG) ex.printStackTrace();};   
    	} else if (BOTON_CONSULTA_TEMP.equals(command)) {
    		try {
    		   mensajesDomus.consultarSensorTemperatura();
    		} catch (Exception ex) { if (DEBUG) ex.printStackTrace();};   
    	} else if (BOTON_CONSULTA_PHOTO.equals(command)) {
    		try {
    		   mensajesDomus.consultarFotosensor();
    		} catch (Exception ex) { if (DEBUG) ex.printStackTrace();};   
    	} else if (BOTON_PARADA.equals(command)) {
    		try {
    		   mensajesDomus.modificarConfigTimer(TIMER_PARADA);
    		} catch (Exception ex) { if (DEBUG) ex.printStackTrace();};   
    	} else if (CAMBIAR_TIMER.equals(command)) {
    		try {
    		   mensajesDomus.modificarConfigTimer(TIMER_DEFECTO); //valor en segundos
    		} catch (Exception ex) { if (DEBUG) ex.printStackTrace();};   
    	} else if (CAMBIAR_MIN_PHOTO.equals(command)) {
    		try {
    		   mensajesDomus.modificarConfigFotosensor((short)PHOTOMIN_DEFECTO);
    		} catch (Exception ex) { if (DEBUG) ex.printStackTrace();};   
    	} else if (CAMBIAR_MIN_TEMP.equals(command) || CAMBIAR_MAX_TEMP.equals(command)) {
    		try {
    		   mensajesDomus.modificarConfigTemperatura((short)Math.round(TEMPMIN_DEFECTO),(short)Math.round(TEMPMAX_DEFECTO));
    		} catch (Exception ex) { if (DEBUG) ex.printStackTrace();};   
    	} else if (COMBO_TIEMPO.equals(command)) {
            JComboBox cb = (JComboBox)e.getSource();
            cambiarUnidades((String)cb.getSelectedItem());
        } else if (COMBO_TEMPERATURA.equals(command)) {
            JComboBox cb = (JComboBox)e.getSource();
            cambiarUnidades((String)cb.getSelectedItem());
        }//Radio buttons look and feel.
    	 else if (LF_METAL.equals(command)) {
    		cambioApariencia(LF_METAL);
    	} else if (LF_SYSTEM.equals(command)) {
    		cambioApariencia(LF_SYSTEM);
    	} else if (LF_MOTIF.equals(command)) {
    		cambioApariencia(LF_MOTIF);
        }
	}

    private void cambioApariencia(String lookAndFeel) {
       if (lookAndFeel != null) {
         if (lookAndFeel.equals(LF_METAL)) {
             lookAndFeel = "javax.swing.plaf.metal.MetalLookAndFeel";
         } else if (lookAndFeel.equals(LF_SYSTEM)) {
             lookAndFeel = UIManager.getSystemLookAndFeelClassName();
         } else if (lookAndFeel.equals(LF_MOTIF)) {
             lookAndFeel = "com.sun.java.swing.plaf.motif.MotifLookAndFeel";
         } else { //valor por defecto
             lookAndFeel = UIManager.getCrossPlatformLookAndFeelClassName();
         }

    	 try {
           UIManager.setLookAndFeel(lookAndFeel);
           SwingUtilities.updateComponentTreeUI(frame);
           frame.pack();
         } 
         catch (ClassNotFoundException e) {
            System.err.println("No se encuentra la clase para el look and feel:"
                               + lookAndFeel);
            System.err.println("Se utiliza la apariencia por defecto.");
         } 
         catch (UnsupportedLookAndFeelException e) {
            System.err.println("No se puede utilizar el look and feel ("
                               + lookAndFeel
                               + ") on this platform.");
            System.err.println("Se utiliza la apariencia por defecto.");
         } 
         catch (Exception e) {
            System.err.println("No se puede obtener el  look and feel ("
                               + lookAndFeel + ").");
            System.err.println("Se utiliza la apariencia por defecto.");
            e.printStackTrace();
         }
       }  
    }

    public void stateChanged(ChangeEvent e) {
        Color newColor = tcc.getColor();
        banner.setForeground(newColor);
    }

    public static void main(String[] args) {
    	
    	//Programamos una tarea para gestionar los eventos
        //y mostramos el entorno gráfico
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
            	createAndShowGUI();
            }
        });
    }
    
    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     */
    public static void createAndShowGUI() {
    	
        //Creamos el panel de contenidos
        JComponent newContentPane = new ControlRemoto();
        newContentPane.setOpaque(true); //Hacemos el panel opaco
        frame.setContentPane(newContentPane);
        
        //Mostramos la ventana
        frame.pack();
        frame.setVisible(true);
    }
    
    @Override
	public void windowActivated(WindowEvent arg0) {
		// Inicializamos los JTextField de parámetros al activar la ventana
    	if (iniParam) {
			iniParam = false;
			try {
			   consultarTodo();
			} catch (Exception ex) { if (DEBUG) ex.printStackTrace();};  
		}
	}

	@Override
	public void windowClosed(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowClosing(WindowEvent arg0) {
		// TODO Auto-generated method stub
		frame.dispose();
		System.exit(0);
	}

	@Override
	public void windowDeactivated(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowDeiconified(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowIconified(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowOpened(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}
	
	public static ControlRemoto getContentPane() {
		return (ControlRemoto)frame.getContentPane();
	}

	//Clase interna para validar el contenido de los JTextFields
	private class Validador extends InputVerifier implements ActionListener {
		
		public boolean shouldYieldFocus(JComponent entrada) {
		   boolean esOK = verify(entrada);
		   if (esOK) {
              return true;
           } else {
              Toolkit.getDefaultToolkit().beep();
              return false;
           }
		}
		
		//Verificamos si los valores introducidos son correctos
		public boolean verify(JComponent entrada) {
            if (entrada == tfTimer) {
                return comprobarTimer(CAMBIAR_VALOR);
            } else if (entrada == tfPhotoMin) {
                return comprobarPhotoMin(CAMBIAR_VALOR);
            } else if (entrada == tfTempMin) {
                return comprobarTempMin(CAMBIAR_VALOR);
            } else if (entrada == tfTempMax) {
                return comprobarTempMax(CAMBIAR_VALOR, TEMPMIN_DEFECTO);	
            } else {
                return true; //Nunca deber�a ocurrir
            }
        }
		
		//Comprobamos que el valor de timer sea correcto
		protected boolean comprobarTimer(boolean cambiar) {
			boolean correcto = true;
			int valorTimer = 0;
			int timerMin = TIMER_SEG_MIN;
            int timerDef = TIMER_DEFECTO;
            int timerMax = TIMER_SEG_MAX;
            String tiempo = " (segundos).";
            if (UNIDAD_TIEMPO.equals(MINUTOS)) {
            	timerMin = TIMER_MIN_MIN;
            	timerDef = convertirSegundosMinutos(timerDef);
            	timerMax = TIMER_MIN_MAX;
                tiempo = " (minutos).";
            }
            String menError = "Debe introducir un valor entre " + timerMin + " y " + timerMax + tiempo;            
            try {
               valorTimer = fmt2Enteros.parse(tfTimer.getText()).intValue();
            } catch (ParseException pe) {
                if (cambiar) valorTimer = timerDef;
            	correcto = false;
                if (DEBUG) pe.printStackTrace();
            }
            //Valor incorrecto
            if ((valorTimer < timerMin) || (valorTimer > timerMax)) {
                if (cambiar) valorTimer = timerDef;
            	   correcto = false;
            }
            if (!correcto) {
               JOptionPane.showMessageDialog(frame,
                     menError, "Error Timer", JOptionPane.ERROR_MESSAGE);
            }   
            //Siempre guardamos el �ltimo valor correcto
            if (correcto) {
               if(UNIDAD_TIEMPO.equals(SEGUNDOS)) {
            	   TIMER_DEFECTO = valorTimer;	   
               } else {
                  TIMER_DEFECTO = convertirMinutosSegundos(valorTimer); //Siempre guardamos segundos
               }
			}
            //Damos formato al valor
            tfTimer.setText(fmt2Enteros.format(valorTimer));
            tfTimer.selectAll();
            
            return correcto;
		}
		
		//Comprobamos que el valor de PhotoMin sea correcto
		protected boolean comprobarPhotoMin(boolean cambiar) {
			boolean correcto = true;
			int valorPhotoMin = 0;
			short photoMin = PHOTOMIN_MIN;
			int photoDef = PHOTOMIN_DEFECTO;
            short photoMax = PHOTOMIN_MAX;
            String menError = "Debe introducir un valor entre " + photoMin + " y " + photoMax + ".";
                    
            try {
               valorPhotoMin = fmt3Enteros.parse(tfPhotoMin.getText()).shortValue();
            } catch (ParseException pe) {
                if (cambiar) valorPhotoMin = photoDef;
            	correcto = false;
                if (DEBUG) pe.printStackTrace();
            }
            //Valor incorrecto
            if ((valorPhotoMin < photoMin) || (valorPhotoMin > photoMax)) {
                if (cambiar) valorPhotoMin = photoDef;
            	correcto = false;
            }
            if (!correcto) {
               JOptionPane.showMessageDialog(frame,
                  menError, "Error MIN Luminosidad", JOptionPane.ERROR_MESSAGE);
            }
            //Guardarmos el �ltimo valor correcto
            if (correcto) PHOTOMIN_DEFECTO = valorPhotoMin;
            
            //Damos formato al valor
            tfPhotoMin.setText(fmt3Enteros.format(valorPhotoMin));
            tfPhotoMin.selectAll();
            
            return correcto;
		}
		
		//Comprobamos que el valor de TempMin sea correcto
		protected boolean comprobarTempMin(boolean cambiar) {
			String menError = null;
			boolean correcto = true;
			double valorTempMin = 0;
			double tempMinMin = TEMPMIN_MIN;
			double tempMinDef = TEMPMIN_DEFECTO;
			double tempMinMax = TEMPMIN_MAX;
			if (UNIDAD_TEMPERATURA.equals(FARENHEIT)) {
				tempMinMin = Math.ceil(convertirCelsiusFarenheit(TEMPMIN_MIN));
				tempMinDef = convertirCelsiusFarenheit(TEMPMIN_DEFECTO);
				tempMinMax = Math.floor(convertirCelsiusFarenheit(TEMPMIN_MAX));
            }
			menError =  "Debe introducir un valor entre " + fmt2Decimales.format(tempMinMin) + 
			            " y " + fmt2Decimales.format(tempMinMax) + ".";
			
            try {
               valorTempMin = fmt2Decimales.parse(tfTempMin.getText()).shortValue();
            } catch (ParseException pe) {
                if (cambiar) valorTempMin = tempMinDef;
            	correcto = false;
                if (DEBUG) pe.printStackTrace();
            }
            //Valor incorrecto
            if ((valorTempMin < tempMinMin) || (valorTempMin > tempMinMax)) {
                if (cambiar) valorTempMin = tempMinDef;
            	correcto = false;
            }
            if (!correcto) {
               JOptionPane.showMessageDialog(frame,
                  menError, "Error MIN Temperatura", JOptionPane.ERROR_MESSAGE);
            }
            //Guardarmos el �ltimo valor correcto
            if (correcto) {
               if (UNIDAD_TEMPERATURA.equals(CELSIUS)) {
                  TEMPMIN_DEFECTO = valorTempMin;
               } else {
            	   TEMPMIN_DEFECTO = convertirFarenheitCelsius(valorTempMin); //Siempre Celsius
               }   
            }
            //Damos formato al valor
            tfTempMin.setText(fmt2Decimales.format(valorTempMin));
            tfTempMin.selectAll();
            
            return correcto;
		}
		
		//Comprobamos que el valor de TempMax sea correcto
		protected boolean comprobarTempMax(boolean cambiar, double minimo) {
			String menError = null;
			boolean correcto = true;
			double valorTempMax = 0;
			double tempMaxMin = Math.round(minimo);
			if (tempMaxMin<minimo) tempMaxMin = tempMaxMin + 1; 
			if (tempMaxMin<TEMPMAX_MIN) tempMaxMin = TEMPMAX_MIN;
			double tempMaxDef = TEMPMAX_DEFECTO;
			double tempMaxMax = TEMPMAX_MAX;
			if (UNIDAD_TEMPERATURA.equals(FARENHEIT)) {
				tempMaxMin = Math.ceil(convertirCelsiusFarenheit(TEMPMAX_MIN));
				tempMaxDef = convertirCelsiusFarenheit(TEMPMAX_DEFECTO);
				tempMaxMax = Math.floor(convertirCelsiusFarenheit(TEMPMAX_MAX));
            }
			menError = "Debe introducir un valor entre " + fmt2Decimales.format(tempMaxMin) + 
			           " y " + fmt2Decimales.format(tempMaxMax) + ".";
            
			try {
               valorTempMax = fmt2Decimales.parse(tfTempMax.getText()).doubleValue();
            } catch (ParseException pe) {
                if (cambiar) valorTempMax = tempMaxDef;
            	correcto = false;
                if (DEBUG) pe.printStackTrace();
            }
            //Valor incorrecto
            if ((valorTempMax < tempMaxMin) || (valorTempMax > tempMaxMax)) {
                if (cambiar) valorTempMax = tempMaxDef;
            	correcto = false;
            }
            if (!correcto) {
               JOptionPane.showMessageDialog(frame,
                  menError, "Error MAX temperatura", JOptionPane.ERROR_MESSAGE);
            }
            //Guardarmos el �ltimo valor correcto
            if (correcto) {
                if (UNIDAD_TEMPERATURA.equals(CELSIUS)) {
                   TEMPMAX_DEFECTO = valorTempMax;
                } else {
             	   TEMPMAX_DEFECTO = convertirFarenheitCelsius(valorTempMax); //Siempre Celsius
                }   
             }
            
            //Damos formato al valor
            tfTempMax.setText(fmt2Decimales.format(valorTempMax));
            tfTempMax.selectAll();
            
            return correcto;
		}
		
		public void actionPerformed(ActionEvent e) {
            JTextField entrada = (JTextField)e.getSource();
            shouldYieldFocus(entrada); //ignore return value
            entrada.selectAll();
        }
    }
	
	//Actualizamos la lectura del sensor de temperatura en pantalla
	public void actualizarValorTemp(double valor, int min, int max) {
		LECTURA_TEMPERATURA = valor; //guardamos la �ltima lectura
		if (UNIDAD_TEMPERATURA.equals(CELSIUS)) {
		   tfTemp.setText(fmt2Decimales.format(valor));
		} else {
			tfTemp.setText(fmt2Decimales.format(convertirCelsiusFarenheit(valor)));	
		}
		actualizarFondoTemp(LECTURA_TEMPERATURA, (int)TEMPMIN_DEFECTO, (int)TEMPMAX_DEFECTO);
	}
	
	//Actualizamos la lectura del sensor de temperatura en pantalla
	public void actualizarFondoTemp(double valor, int min, int max) {
		if (LECTURA_TEMPERATURA != SIN_INICIALIZAR) {
		   if (valor<min) {
              if (timerBlink.isRunning()) timerBlink.stop();	
              tfTemp.setBackground(Color.YELLOW);	
           } else {
              if (valor>max) {
        	     if (!timerBlink.isRunning()) timerBlink.start();
              } else {
        	     if (timerBlink.isRunning()) timerBlink.stop();
        	     tfTemp.setBackground(Color.WHITE);
              }
           }
		}   
	}
	
	//Actualizamos la lectura del fotosensor en pantalla
    public void actualizarValorPhoto(int valor, int min) {
    	LECTURA_PHOTOSENSOR = valor;
    	tfPhoto.setText(fmt3Enteros.format(valor));
        actualizarFondoPhoto(LECTURA_PHOTOSENSOR, min);
    }	
    
  //Actualizamos la lectura del fotosensor en pantalla
    public void actualizarFondoPhoto(int valor, int min) {
       	if (LECTURA_PHOTOSENSOR != SIN_INICIALIZAR) {   
    	   if (valor<min) {
	          tfPhoto.setBackground(Color.RED);	
	       } else {
	          tfPhoto.setBackground(Color.WHITE);
	       }   
	    }
	}

    //Actualizamos el estado del sensor de efecto Hall en pantalla
	public void actualizarHall(String valor) {
		tfHall.setText(valor);
		if (valor.equals("On")) {
        	tfHall.setBackground(Color.GREEN);
        } else {
        	tfHall.setBackground(Color.WHITE);
        }
	}
	
	//Actualizamos el valor del parametro asignado al Temporizador
	public void actualizarTimer(int valor) {
		if (!tfTimer.isFocusOwner()) {
		  TIMER_DEFECTO = valor;
		  if (UNIDAD_TIEMPO.equals(SEGUNDOS)) {
		     tfTimer.setText(fmt2Enteros.format(valor));
		  } else {
			 tfTimer.setText(fmt2Enteros.format(convertirSegundosMinutos(valor)));	
		  }
		  if (TIMER_DEFECTO == TIMER_PARADA) {
			if (timerBlink.isRunning()) timerBlink.stop();
			  tfTemp.setText("---");
			  tfTemp.setBackground(Color.RED);
			  tfPhoto.setText("---");
			  tfPhoto.setBackground(Color.RED);
			  tfTimer.setBackground(Color.RED);
		  } else {
			tfTimer.setBackground(Color.WHITE);
		  }
		}
	 }
	
	//Actualización valor mínimo encendido fotosensor
	public void actualizarPhotoMin(int valor) {
		if (!tfPhotoMin.isFocusOwner()) {
		  PHOTOMIN_DEFECTO = (short) valor;
		  tfPhotoMin.setText(Integer.toString(valor));
		  if (TIMER_DEFECTO != TIMER_PARADA) {
	        actualizarFondoPhoto(LECTURA_PHOTOSENSOR, PHOTOMIN_DEFECTO);
		  }
		}
	}

	//Actualización valor mínimo sensor temperatura 
	public void actualizarTempMin(int valor) {
	   if (!tfTempMin.isFocusOwner()) {
	     TEMPMIN_DEFECTO = valor;
	     if (UNIDAD_TEMPERATURA.equals(CELSIUS)) {
		   tfTempMin.setText(fmt2Decimales.format(valor));
		 } else {
		   tfTempMin.setText(fmt2Decimales.format(convertirCelsiusFarenheit(valor)));	
		 }
	     if (TIMER_DEFECTO != TIMER_PARADA) {
		   actualizarFondoTemp(LECTURA_TEMPERATURA, (int)TEMPMIN_DEFECTO, (int)TEMPMAX_DEFECTO);
	     } 
	   }
	}

	//Actualización valor máximo sensor temperatura
	public void actualizarTempMax(int valor) {
	   if (!tfTempMax.isFocusOwner()) {
	     TEMPMAX_DEFECTO = valor;
	     if (UNIDAD_TEMPERATURA.equals(CELSIUS)) {
		   tfTempMax.setText(fmt2Decimales.format(valor));
		 } else {
		   tfTempMax.setText(fmt2Decimales.format(convertirCelsiusFarenheit(valor)));	
		 }
	     if (TIMER_DEFECTO != TIMER_PARADA) {
		   actualizarFondoTemp(LECTURA_TEMPERATURA, (int)TEMPMIN_DEFECTO, (int)TEMPMAX_DEFECTO);
	     } 
	   }
	}
	
	//Insertamos mensajes en el JTextArea
	public void registrarMensaje(String mensaje) {
		JPanel pEventos = (JPanel)panelEtiquetas.getComponentAt(1);
        JScrollPane pScroll = (JScrollPane)pEventos.getComponent(0);
		JTextArea taMen = (JTextArea)pScroll.getViewport().getView(); 
		taMen.append(mensaje + NEWLINE_DOBLE);
		if (taMen.getLineCount()>MAX_LINEAS_MENSAJES) {
			taMen.setText("");
		}
		taMen.setCaretPosition(taMen.getDocument().getLength());
    }
	
	//Cambio valores mostrados según las unidades seleccionadas
	//¡OJO! En el cambio de minutos a segundos se hace redondeo porque
	//sólo se pueden introducir valores enteros
	private void cambiarUnidades(String unidad) {
		double temperatura = 0;
		int tiempo = 0;
		if (unidad.equals(CELSIUS) && !unidad.equals(UNIDAD_TEMPERATURA)) {
			UNIDAD_TEMPERATURA = CELSIUS;
			if ((LECTURA_TEMPERATURA != SIN_INICIALIZAR) && (TIMER_DEFECTO != TIMER_PARADA)) {
			   tfTemp.setText(fmt2Decimales.format(LECTURA_TEMPERATURA));
			}  
			tfTempMin.setText(fmt2Decimales.format(TEMPMIN_DEFECTO));
			tfTempMax.setText(fmt2Decimales.format(TEMPMAX_DEFECTO));
		} else if (unidad.equals(FARENHEIT) && !unidad.equals(UNIDAD_TEMPERATURA)) {
			UNIDAD_TEMPERATURA = FARENHEIT;
			if ((LECTURA_TEMPERATURA != SIN_INICIALIZAR) && (TIMER_DEFECTO != TIMER_PARADA)) {
				temperatura = convertirCelsiusFarenheit(LECTURA_TEMPERATURA);
			    tfTemp.setText(fmt2Decimales.format(temperatura));
		    }
			temperatura = convertirCelsiusFarenheit(TEMPMIN_DEFECTO);
			tfTempMin.setText(fmt2Decimales.format(temperatura));
			temperatura = convertirCelsiusFarenheit(TEMPMAX_DEFECTO);
			tfTempMax.setText(fmt2Decimales.format(temperatura));
		} else if (unidad.equals(SEGUNDOS) && !unidad.equals(UNIDAD_TIEMPO)) {
			UNIDAD_TIEMPO = SEGUNDOS;
			tfTimer.setText(fmt2Enteros.format(TIMER_DEFECTO));
		} else if (unidad.equals(MINUTOS) && !unidad.equals(UNIDAD_TIEMPO)) {
			UNIDAD_TIEMPO = MINUTOS;
			tiempo = convertirSegundosMinutos(TIMER_DEFECTO);
			tfTimer.setText(fmt2Enteros.format(tiempo));
		}
	}
	
	//Conversion grados Celsius a Farenheit
	private double convertirCelsiusFarenheit(double celsius) {
		return ((celsius*9/5)+32);
	}
	
	//Conversion grados Farenheit a Celsius
	private double convertirFarenheitCelsius(double farenheit) {
		return (Math.round((farenheit-32)*5/9));
	}

	//Conversion segundos a minutos
	private int convertirSegundosMinutos(int segundos) {
		short minutos = 0;
		if (TIMER_DEFECTO != TIMER_PARADA) {
		  minutos = (short)Math.round(segundos/60);
		  if (minutos<=0) minutos = 1;
		}
		return (minutos);
	}
	
	//Conversion minutos a sengundos
	private int convertirMinutosSegundos(int minutos) {
		return (int)(minutos*60);
	}
	
	//Clase interna para implementar un programador de tareas 
	private class TimerListener implements ActionListener {
		public TimerListener(ControlRemoto cr) {
		}

		public void actionPerformed(ActionEvent e) {
		   short mensajes = 3;	
		   String comando = e.getActionCommand();
		   
		   if (comando.equals(TIMER_BLINK)) {
		      if (tfTemp.getBackground().equals(Color.YELLOW)) {
			   tfTemp.setBackground(Color.WHITE);
		      } else {
			      tfTemp.setBackground(Color.YELLOW);
		      }
		   } else if (comando.equals(TIMER_WATCHDOG)) {
			  switch (secuencia) {
			     case 0:
			       mensajesDomus.consultarConfigTemperatura();
				   break;
			     case 1:
			       mensajesDomus.consultarConfigFotosensor();
			       break;
			     case 2:
			       mensajesDomus.consultarConfigTimer();	 
			       break;
			  }
			  secuencia = (short)((secuencia + 1) % mensajes);
		   }	  
		}   
	}
	 
	//Consuta de todos los parámetros de configuración
	//y fuerza la lectura de los sensores de luz y temperatura
	public void consultarTodo() throws Exception {
		
		consultarParametros();
		if (TIMER_DEFECTO != TIMER_PARADA) {
		   Thread.sleep(RETARDO);
		   mensajesDomus.consultarAmbos();
		}
		
	}
	
    //Consuta de todos los parámetros de configuración
	public void consultarParametros() throws Exception {
		
		Thread.sleep(RETARDO);
		mensajesDomus.consultarConfigTimer();
		
		Thread.sleep(RETARDO);
		mensajesDomus.consultarConfigFotosensor();
		
		Thread.sleep(RETARDO);
		mensajesDomus.consultarConfigTemperatura();
		
	}
}
